; 

;   Build this demo with the "Console Assemble & Link" option. It will
;   crash if you forget and build it as a GUI app and run it.

    .486
    .model flat, stdcall
    option casemap :none   ; case sensitive

; 

    include \masm32\include\windows.inc

    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\wsock32.inc

    include \masm32\macros\macros.asm

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\wsock32.lib    


include \masm32\include\debug.inc
includelib \masm32\lib\debug.lib


    main PROTO

; 

.const

BromeliaSQLPort                  equ   6677
MaxSizeOfSendBuffer	         equ   1000                   ; max size of sending buffer for queries which are being to send to server is 1 KB

MaxSizeOfReceiveBuffer           equ   10000+1                ; max size of receiving buffer for results which have been come from server is 10 KB (one extra byte is fore internal use of sockets)

MaxIntStrLength                  equ   10
MaxLengthOfColumnName		   equ   30





.data


ColumnsList Struct
      ColumnName        db          MaxLengthOfColumnName+1 dup(0), 0
	ColumnType		db		0
	ColumnSize		dd		0
      StrSize           dd          0
	PointerToNext	dd		0			; this structure will be a link-list
ColumnsList EndS




QuoteVar                         db    "'", 0
AndVar                           db    
" AND ", 0
ConnectionQuery3                 db    "Password='", 0
SemicolonVar                     db    ";", 0
FinalConnectionQuery             db    MaxSizeOfSendBuffer     dup(0), 0


ReceivingBuffer                  db    MaxSizeOfReceiveBuffer  dup(0), 0


QueryStr                         db    MaxSizeOfSendBuffer     dup(0), 0


ExitMsg                          db    "CONN KILL", 0                        
ConnectionOK                     db    "CONN OK", 0  
ExitCommand                      db    "exit", 0
TextMessage			         db    "TEXT MSG", 0



ResultMessage                    db    "RES MSG", 0
ResultSetMessage			   db	   "RESSET MSG", 0
MessageReceived                  db    "RECV MSG", 0
MessageEnded                     db    "END MSG", 0

LocalhostServer                  db    "127.0.0.1", 0


BlankStr                         db    0










IPStrPtr                         dd    0
UsernameStrPtr                   dd    0
PasswordStrPtr                   dd    0
QueryPtr                         dd    0

HeapHandle                       dd    0
ResultsetPtr                     dd    0
NumberOfRetrievedRows            dd    0
Counter                          dd    0
TempPtr                          dd    0
TempPtr2                         dd    0
AddressOfPreviousElement         dd    0
AddressOfFirstElement            dd    0
RSSizeOfEachRow                  dd    0
RSNumberOfColumns                dd    0
RSNumberOfRows                   dd    0
RSFormattedRowPtr                dd    0
RSFormattedRowTitlePtr           dd    0
RSTempPtr                        dd    0
RSSizeOfFormattedRow             dd    0
StrSize                          dd    0
ListeningPort                    dd    BromeliaSQLPort       ; the server will listen to this port by default. This port would specify by user manually




.data?
S1        SOCKET ?
S2        SOCKET ?
Sin1      sockaddr_in <>
Sin2      sockaddr_in <>
WSAData   WSADATA <>



    .code

start:

    call main

    exit




; 

main proc

    mov     IPStrPtr, input("Server IP (Leave this field blank if the server is running on localhost): ")
    invoke  szTrim, IPStrPtr

    invoke  StrLen, IPStrPtr
    cmp     eax, 0
    jne     @F

    invoke  szCopy, addr LocalhostServer, IPStrPtr

@@:



    invoke  WSAStartup, 0101h, ADDR WSAData
    invoke  socket, PF_INET, SOCK_STREAM, IPPROTO_TCP
    mov     S1, eax
    mov     ax, AF_INET
    mov     Sin1.sin_family, ax
    xor     eax, eax
    mov     Sin1.sin_addr, eax
    invoke  inet_addr, IPStrPtr
    mov     Sin1.sin_addr, eax
    invoke  htons, ListeningPort                               ; listen to a specified port
    mov     Sin1.sin_port, ax

    invoke  connect, S1, addr Sin1, SIZEOF Sin1                

    cmp     eax, SOCKET_ERROR
    jne     ServerFound


    write   "Connection could not establish. Possibly the server is not running on the specified address or the server address is incorrect.", 13, 10
    ret
    
ServerFound:

ConnectionEstablished:



    write   "Connected to server.", 13, 10                      ; connection to server is established now

    write   " ", 13, 10


InfiniteQueryLoop:

    mov     QueryPtr, input("BromeliaSQL", 62, " ")
    invoke  szTrim, QueryPtr                                    ; remove spaces from both sides of query string

    invoke  StrLen, QueryPtr
    invoke  szCmp, QueryPtr, addr ExitCommand
    
    invoke  send, S1, addr QueryStr, sizeof QueryStr, 0         ; send the entered query to the server
    invoke  recv, S1, addr ReceivingBuffer, sizeof ReceivingBuffer, 0


    invoke  send, S1, addr QueryStr, sizeof QueryStr, 0         ; send the entered query to the server

    invoke  recv, S1, addr ReceivingBuffer, sizeof ReceivingBuffer, 0


    print addr ReceivingBuffer

    write   " ", 13, 10


    jmp InfiniteQueryLoop

    ret

main endp

; 

end start

